<template>
  <div class="badges-list">
    <span
      class="badge-item"
      v-for="(skill, index) in badgesList"
      :key="`skill-${index}`"
      >{{ skill }}</span
    >
    <span class="badge-item more" v-if="needMore" @click="show = true"
      >+{{ moreCount }}</span
    >
    <span class="badge-item more" v-if="show" @click="show = false">
      <v-icon>mdi-chevron-up</v-icon>
    </span>
  </div>
</template>
<script lang="ts">
import { Component, Prop, Vue } from "vue-property-decorator";

@Component
export default class MoreBadges extends Vue {
  show = false;
  @Prop({ required: true }) badges!: Array<any>;
  @Prop({ default: 2 }) readonly maxLength!: number;

  get moreCount() {
    return this.badges.length - this.maxLength;
  }
  get needMore() {
    return this.badges.length > this.maxLength && !this.show;
  }

  get badgesList() {
    if (this.show) {
      return this.badges;
    }
    return this.badges.slice(0, this.maxLength);
  }
}
</script>
<style lang="scss">
.badges-list {
  .badge-item {
    padding: 4px 12px;

    background: #eef1f3;
    border-radius: 4px;

    font-weight: normal;
    font-size: 15px;
    line-height: 20px;
    color: #7c8793;
    &.more {
      background: #e9f1f9;
      cursor: pointer;
    }
    margin-right: 8px;
    margin-bottom: 8px;
    display: inline-block;
  }
}
</style>
